/*
SIGNATURE API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package signaturesapi

import (
	"encoding/json"
)

// checks if the InsignConfigurationFree type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &InsignConfigurationFree{}

// InsignConfigurationFree struct for InsignConfigurationFree
type InsignConfigurationFree struct {
	Username string `json:"username"`
	ApiUrl string `json:"api_url"`
	WebUrl string `json:"web_url"`
}

// NewInsignConfigurationFree instantiates a new InsignConfigurationFree object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewInsignConfigurationFree(username string, apiUrl string, webUrl string) *InsignConfigurationFree {
	this := InsignConfigurationFree{}
	this.Username = username
	this.ApiUrl = apiUrl
	this.WebUrl = webUrl
	return &this
}

// NewInsignConfigurationFreeWithDefaults instantiates a new InsignConfigurationFree object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewInsignConfigurationFreeWithDefaults() *InsignConfigurationFree {
	this := InsignConfigurationFree{}
	return &this
}

// GetUsername returns the Username field value
func (o *InsignConfigurationFree) GetUsername() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Username
}

// GetUsernameOk returns a tuple with the Username field value
// and a boolean to check if the value has been set.
func (o *InsignConfigurationFree) GetUsernameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Username, true
}

// SetUsername sets field value
func (o *InsignConfigurationFree) SetUsername(v string) {
	o.Username = v
}

// GetApiUrl returns the ApiUrl field value
func (o *InsignConfigurationFree) GetApiUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ApiUrl
}

// GetApiUrlOk returns a tuple with the ApiUrl field value
// and a boolean to check if the value has been set.
func (o *InsignConfigurationFree) GetApiUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ApiUrl, true
}

// SetApiUrl sets field value
func (o *InsignConfigurationFree) SetApiUrl(v string) {
	o.ApiUrl = v
}

// GetWebUrl returns the WebUrl field value
func (o *InsignConfigurationFree) GetWebUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.WebUrl
}

// GetWebUrlOk returns a tuple with the WebUrl field value
// and a boolean to check if the value has been set.
func (o *InsignConfigurationFree) GetWebUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.WebUrl, true
}

// SetWebUrl sets field value
func (o *InsignConfigurationFree) SetWebUrl(v string) {
	o.WebUrl = v
}

func (o InsignConfigurationFree) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o InsignConfigurationFree) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["username"] = o.Username
	toSerialize["api_url"] = o.ApiUrl
	toSerialize["web_url"] = o.WebUrl
	return toSerialize, nil
}

type NullableInsignConfigurationFree struct {
	value *InsignConfigurationFree
	isSet bool
}

func (v NullableInsignConfigurationFree) Get() *InsignConfigurationFree {
	return v.value
}

func (v *NullableInsignConfigurationFree) Set(val *InsignConfigurationFree) {
	v.value = val
	v.isSet = true
}

func (v NullableInsignConfigurationFree) IsSet() bool {
	return v.isSet
}

func (v *NullableInsignConfigurationFree) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableInsignConfigurationFree(val *InsignConfigurationFree) *NullableInsignConfigurationFree {
	return &NullableInsignConfigurationFree{value: val, isSet: true}
}

func (v NullableInsignConfigurationFree) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableInsignConfigurationFree) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


